<?php
require_once('contact_class.php');

/**
 * A contact template is used for inheritance, so that you could
 * base your contacts with common properties on one of these.
 */
class contact_template_class extends contact_class
{
	/** object type */
	var $type = 'contact_template';
	/** database table */
	var $db_table = 'contact';
	/** template or not */
	var $is_template = true;

	function get_properties()
	{
		$this->properties = get_object_properties('contact');
		unset($this->properties['default']['contact_name']);
		unset($this->properties['default']['alias']);
		unset($this->properties['default']['template']);
		unset($this->properties['var_index']['contact_name']);
		unset($this->properties['var_index']['alias']);
		unset($this->properties['var_index']['template']);
		unset($this->properties['special']['template']);
		$this->properties['default']['register'] = 0;
		$this->properties['default']['name'] = '';
		$this->properties['var_index'] = array_merge(array('name' => 'string'), $this->properties['var_index']);
		$this->properties['topic'] = 'name';
		$this->properties['required'] = array('name');
		return $this->properties;
	}

	/**
	 * Prepare the object for drawing in the gui
	 */
	function prepare_draw()
	{
		parent::prepare_draw();

		$this->expand_object();

		unset($this->obj['template']);
		unset($this->obj['contact_name']);
		unset($this->obj['alias']);
	}
}
