<?php

require_once(dirname(__FILE__).'/../user_class.php');
require_once('base_controller.php');

/**
 * Controller for configuring user access
 */
class access_controller extends base_controller {
	var $name = 'Local Users';

	/**
	 * @return array [username] => userobj
	 */
	private function get_users()
	{
		$users = array();
		foreach (user_class::get_users() as $user)
			$users[$user->get_object_name()] = $user;
		ksort($users);
		return $users;
	}
	
	/**
	 * Verify user permissions
	 */
	function __construct($input) {
		$access = get_nacoma_access('access_rights');
		if (!in_array(NACOMA_ACCESS_FULL_ACCESS, $access))
			deny_access("You need full 'access_rights' permissions to modify permissions.");

		$this->input = $input;

	}

	/**
	 * Print user access list
	 */
	function index() {
		$objects = $this->get_users();
		$user = new user_class('new');
		$objects['new'] = $user;
		$description = '<strong>Manage Local Users</strong></p>
<p>This is where you configure which users are able to log into monitor using the Default driver.</p>
<div class="note"><p><strong>Please note:</strong> If you change your password or delete yourself you will be logged out.</p></div>';
		$input = $this->input;
		require_once(dirname(__FILE__).'/../../templates/many-per-page.php');
	}

	/**
	 * Delete user
	 */
	function delete() {
		user_class::get_users();
		$deluser = $_REQUEST['delete'];
		echo "<p><b>Removing user '$deluser'</b></p>\n";

		$user = new user_class($deluser);
		$user->delete_object();

		// @todo this really should be a redirect...
		$this->index();
	}

	/**
	 * Save user changes
	 */
	function Submit() {
		global $Config, $page;
		user_class::get_users();
		$users = $_REQUEST['user'];
		$errors = array();
		
		foreach ($users as $userid => $userobj) {
			if('new' == $userid && !$userobj['username'] && !$userobj['password'][1] && !$userobj['password'][2]) {
				// skip validating the 'new' user if it's empty
				continue;
			}
			$user = new user_class($userid);
			$user->lazy_write = true;
			$user->obj = $userobj;
			if(!$user->save_object()) {
				$errors[$userid] = $user->validation_error_list['password'];
			}
		}

		if($errors) {
			$page->print_validation_error_table(new user_class(), $errors);
		} else {
			user_class::write_users();
		}

		// @todo this really should be a redirect...
		$this->index();
	}
}
