<?php require_once ('mselect.php');

/**
 * An mselect derived widget that only shows services that have PNP graphs
 */
class pnp_page_service_mselect_widget extends mselect_widget {
	private static $services = array();
	private static $has_rendered_javascript = false;
	private static function _get_services() {
		if(self::$services) {
			return self::$services;
		}
		foreach(pnp_page_class::get_available_graphs() as $services) {
			foreach ($services as $service => $_) {
				if(object_class::can_user_read('service', $service)) {
					self::$services[$service] = $service;
				}
			}
		}
		return self::$services;
	}
	function render($obj, $token, $value) {
		if(!$obj instanceof pnp_page_class) {
			throw new InvalidArgumentException("Must provide pnp_page_class to ".__METHOD__);
		}
		$sel_tmp = array();
		if(is_array($obj->properties['special'][$token])) {
			$sel_tmp = $obj->properties['special'][$token];
		}
		else {
			$objs = self::_get_services();
			if(isset($objs)) {
				$sel_tmp = $objs;
			}
		}
		$value = explode(',', $value);
		parent::make_multi_selection(
			$sel_tmp,
			$value,
			$obj->type."[" . $obj->id . "][" . $token . "]",
			$obj->id
		);
	}
}
