<?php
require_once('classes/command_class.php');
require_once('classes/cmd_test_class.php');
require_once('include/db_config.inc.php');
require_once('include/nacoma_access.inc.php');

header('Cache-Control: no-cache');
?>
		<meta http-equiv="Pragma" content="no-cache" />
		<meta http-equiv="Pragma-directive" content="no-cache" />
		<meta http-equiv="Cache-directive" content="no-cache" />
<?php

echo "<pre>";
$cmd_obj = new command_class();
$macros = $cmd_obj->getNagiosUserConfig();
if (isset($_GET['cmd_str'])) {
	$access = get_nacoma_access('test_this_command');
	if (!in_array(NACOMA_ACCESS_FULL_ACCESS, $access)) {
		exit('You are not allowed to test this command.');
	}
	cmd_test::runcmd($_GET['cmd_str'], $macros, isset($_GET['cmdTestNode']) ? $_GET['cmdTestNode'] : false);
	exit;
}

$obj = array();
// check if serviceCheck
parse_str($_SERVER['QUERY_STRING'], $q);
$obj_id = empty($q['cmdID']) ? false : $q['cmdID'];
$host_id = empty($q['hostId']) ? false : $q['hostId'];
$cmd_args = empty($q['cmdArgs']) && !is_numeric($q['cmdArgs']) ? false : $q['cmdArgs'];
$address = empty($q['address']) ? false : $q['address'];
$cmd_node = empty($q['cmdTestNode']) ? false : $q['cmdTestNode'];
if ($cmd_args === 'false') {
	$cmd_args = false;
}
if ($obj_id === 'new') {
	$obj_id = false;
}

$obj = $host = $service = $command = false;
if (!empty($q['selected_command_id']) && is_numeric($q['selected_command_id'])) {
	$command_id = $q['selected_command_id'];
} else {
	$command_id = false;
}

if (isset($q['obj_type']) && $q['obj_type'] === 'service') {
	$access = get_nacoma_access('test_this_service');
	if (!in_array(NACOMA_ACCESS_FULL_ACCESS, $access)) {
		exit('You are not allowed to test this service.');
	}
	require_once('classes/service_class.php');
	$service = new service_class($obj_id);
	$service->template_expand_object();
	if (!$host_id) {
		$host_id = $service->master_obj_id;
	}
	$macros['SERVICEDESCRIPTION'] = $service->obj['service_description'];
	$obj = $service;
}
if ($host_id) {
	$access = get_nacoma_access('test_this_host');
	if (!in_array(NACOMA_ACCESS_FULL_ACCESS, $access)) {
		exit('You are not allowed to test this host.');
	}
	require_once('classes/host_class.php');
	$host = new host_class($host_id);
	$host->template_expand_object();
	$macros['HOSTADDRESS'] = !empty($address) ? $address : $host->obj['address'];
	$macros['HOSTNAME'] = $host->obj['host_name'];
	$macros['HOSTALIAS'] = $host->obj['alias'];
	if (!empty($host->obj['display_name'])) {
		$macros['HOSTDISPLAYNAME'] = $host->obj['display_name'];
	} else {
		$macros['HOSTDISPLAYNAME'] = '';
	}

	if (!$obj) {
		$obj = $host;
	}
}

if ($obj) {
	if (!$command_id) {
		$command_id = $obj->obj['check_command'];
	}
	if ($cmd_args === false && isset($obj->obj['check_command_args']) && (!empty($obj->obj['check_command_args']) || is_numeric($obj->obj['check_command_args']))) {
		$cmd_args = $obj->obj['check_command_args'];
	}
}
$command = new command_class($command_id);
$cmd_line = $command->obj['command_line'];

# add the command arguments as macros
if ($cmd_args !== false) {
	$args = preg_split('/(?<!\\\)!/', $cmd_args);
	for ($i = 0; $i < sizeof($args); $i++) {
		$macros['ARG' . ($i + 1)] = $args[$i];
	}
}

cmd_test::runcmd($cmd_line, $macros, $cmd_node);
echo "</pre>";
