<?php
/**
 * file: delete.php
 *
 * Handle delete requests for various objects
 */
require_once('classes/common_gui.php');
require_once('include/objlock.inc.php');

if (!$input->obj_type) {
	require_once('configure.php');
	exit(0);
}

$page->html_start();

die_if_locked_hard();

# make sure the passed object type is actually supported
# (that is, there is a class and a class-file for it)
$class_name = $input->obj_type . '_class';
if (!is_file("classes/$class_name.php") || in_array($input->obj_type, $input->protected)) {
	echo "$input->obj_type is not a supported object type<br />";
	$page->html_end();
	exit(0);
}

#####
if ($DEBUG){
	$input->debug_print();
}


require_once('classes/' . $input->obj_type . '_class.php');

$obj = new $class_name();
if ($input->master_obj_id)
  $obj->master_obj_id = $input->master_obj_id;

$res = false;

switch ( strtolower($input->action) ) {
	case 'delete':
	$obj->id 	= $input->obj_id;
	$obj->obj 	= $input->obj;
	$res = $obj->delete_object();
	break;

	case 'force_delete':
	$obj->id 	= $input->obj_id;
	$obj->obj 	= $input->obj;
	$res = $obj->banish_object();
	break;

}

$page->print_message($obj->get_deletion_message());

// provide back link
echo "</div><div class=\"magic max\">";
if ($obj->master_obj_id){
	echo "<a href=\"edit.php?obj_type=".$obj->type."&master_obj_id=".$obj->master_obj_id."\">back</a>";
} else {
	echo "<a href=\"edit.php?obj_type=".$obj->type."&list=true\">back</a>";
}
echo "</div><div>";

if ($res)
	echo top_bar_class::add_unsaved_warning();

$page->html_end();
