#!/bin/sh
#
# Copyright(c) 2007 op5 AB
# All rights reserved
#
exec 2>&1
IFS='
'
cd /opt/plugins/
pluginlist() {
	/usr/bin/find /opt/plugins/ -type f -perm /1|sed 's/^\/opt\/plugins\///g' |
	grep -v \.pm$ |
	grep -v ^utils.sh$ |
	grep -v '~$'
}

if (( ${#} != 1 )); then {
	#
	for plugin in `pluginlist`; do
		echo "<a href='?show=${plugin}'>${plugin}</a><br />"
	done
	#
} else {
	#
	if (( ${#1} > 64 )); then {
		echo Too long parameter
		exit 2
	}
	#
	fi
printit() {
	case "${1}" in
		suid/check_megaraid)
			echo No help available.
		;;
		check_ipmi)
			echo No help available as this user. You have to run /opt/plugins/check_ipmi -h
			echo from the terminal
		;;
		check_ls_log)
			echo There is no help available for this plugin.
		;;
		*)
			# Disallow any parameters that isn't found in the pluginlist
			# Disallow any plugins that has .. in their pathnames
			export PLUGIN=`pluginlist|grep -- "^${1}$"|grep -v '\.\.'`
			# Only allow plugins with a-z, A-Z, /.-_ and 0-9 in their filenames
			PLUGIN=`echo ${PLUGIN} |  sed 's/[^a-zA-Z\/\.-_0-9]//g'`
			if (( ${#PLUGIN} == 0 )); then {
				echo No such plugin
			} else {
				if [ -x "./${PLUGIN}" ]; then
					./${PLUGIN} -h
				else
					echo No such file
				fi
			}
			fi
		;;
	esac
}
#
# Workaround to that < and > have a special meaning in HTML.
#
printit "${1}" 2>&1| grep -v 'Unknown option\|arguments!' |
grep -v '^Error:\|requires an argument$'|
grep -v 'You did not supply enough arguments.'|
sed 's/>/\&gt;/g' | sed 's/</\&lt;/g'
}
fi
