<?php
/*
 * Copyright(C) 2003-2005, 2007 op5 AB
 * All rights reserved.
 *
 *
 * "Combined Graphs" is our term of "PNP special templates"
 */

require_once('include/webconfig.inc.php');
require_once('classes/common_gui.php');
require_once('include/objlock.inc.php');

$page->html_start("Combined Graphs");

if(!is_super_user())
  deny_access("You need superuser access to modify permissions.");

die_if_locked_hard();

if (!in_array(NACOMA_ACCESS_FULL_ACCESS, get_nacoma_access('pnp'))) {
  deny_access("You need full 'access_rights' permissions to modify Graphs.");
}

$mode = "";
$type_list = array("area", "line1", "line2", "line3");
if (isset($_GET['mode'])) {
	$mode = $_GET['mode'];
	$file = isset($_GET['file']) ? $_GET['file'] : false;
	$template = array();
	if (substr($file, -3) != "php") {
		$file = "$file.php";
	}
	$full_path = "/opt/monitor/op5/pnp/templates.special/$file";

	$title = isset($template['title']) ? $template['title'] : '';
	$comment = isset($template['comment']) ? $template['comment'] : '';
	$type = isset($template['type']) ? $template['type'] : '';
	$service = isset($template['service']) ? $template['service'] : '';

	switch ($mode) {
		case "edit":
			echo "<strong>Editing $file</br />";
			echo "<br />";
			$content = file_get_contents($full_path);
			if ($content) {
				$lines = explode("\n", $content);

				foreach ($lines as $line) {
					if (substr($line,0,6) === '$title') {
						eval($line);
						$template['title'] = $title;
					}

					if (substr($line,0,8) === '$service') {
						eval($line);
						$template['service'] = $service;
					}

					if (substr($line,0,6) === '$hosts') {
						eval($line);
						$template['hosts'] = $hosts;
					}

					if (substr($line,0,5) === '$type') {
						eval($line);
						$template['type'] = $type;
					}

					if (substr($line,0,8) === '$comment') {
						eval($line);
						$template['comment'] = $comment;
					}
				}
			}
			break;

		case "save":
			$file = $_POST['file'];
			$title = $_POST['title'];
			$comment = $_POST['comment'];
			$type = $_POST['type'];
			$service = $_POST['service'];
			$hosts = $_POST['hosts'];

			$content = '<?php'."\n";
			$content.= "#NACOMA Generated - Don't edit by hand.\n";
			$content.= "\$title=\"$title\";\n";
			$content.= "\$comment=\"$comment\";\n";
			$content.= "\$type=\"$type\";\n";
			$content.= "\$service=\"$service\";\n";

			$content.= "\$hosts=array(";
			foreach ($hosts as $host) {
				$content.= "'$host',";
			}
			$content = substr($content, 0, -1);
			$content.= ");\n";
			$content.= "include(\"include/\$type.inc.php\");\n";

			$content.= '?>'."\n";
			// Removing this makes my syntax highlighting sad :(
			?><?php

			$full_path = "/opt/monitor/op5/pnp/templates.special/$file";
			file_put_contents($full_path, $content, LOCK_EX);
			echo "$file successfully saved..<br />\n";
			echo "<br />";
			echo "<a href='pnp.php'>More actions</a>";
			$page->html_end();
			exit;
			break;

		case "delete":
			if ($file) {
				if (isset($_GET['confirm'])) {
					switch ($_GET['confirm']) {
						case "yes":
							unlink($full_path);
							echo "$file Deleted...<br />";
							echo "<br />";
							echo "<a href='pnp.php'>More actions</a>";
							break;
						case "no":
							# Do nothing
							break;
					}
				} else {
					echo "Do you really want to delete file: " . $file . "?<br />";
					echo "<img src='/monitor/op5/pnp/image?tpl=" . substr($file, 0, -4) . "' border='1' /><br />";
					echo "<a href='pnp.php?mode=delete&file=$file&confirm=yes'>DELETE</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href='pnp.php'>Cancel</a>";
				}

				$page->html_end();
				exit;
			} else {
				echo "Can't find any file<br />";
				echo "<br />";
				echo "<a href='pnp.php'>Start over</a>";
				$page->html_end();
				exit;
			}
			break;

		case "Add":
		case "add":
			if (file_exists($full_path)) {
				echo "Error: file $file already exists, please chose another name for the Combined Graph.<br />";
				echo "<a href='pnp.php'>Start over</a>";
				$page->html_end();
			}

			echo "<strong>Creating file:</strong> $file<br />";
			break;
	}

	$title = isset($template['title']) ? $template['title'] : '';
	$comment = isset($template['comment']) ? $template['comment'] : '';
	$type = isset($template['type']) ? $template['type'] : '';
	$service = isset($template['service']) ? $template['service'] : '';

	echo "<table 'border=0'>";
	echo "<form action='pnp.php?mode=save' method='post'>";
	echo "<tr><td>";
	echo "Title:";
	echo "</td><td><input type='text' name='title' value='$title'></td></tr>";
	echo "<tr><td>Comment:</td><td><input type='text' name='comment' value='$comment'></td></tr>";
	echo "<tr><td>Type:</td><td><select name='type'>";
	foreach ($type_list as $list_item) {
		if ($list_item == $type) {
			echo "<option value='$list_item' selected='selected'>$list_item</option>\n";
		} else {
			echo "<option value='$list_item'>$list_item</option>\n";
		}
	}
	echo "</select></td></tr>";
	echo "<tr><td>Service:</td><td>";
	echo "<select name='service' id='pnp_svc_select'>";
	$legal_objects = get_objects_for_user('service');
	$result = pdo_exec_query("SELECT id, service_description FROM service WHERE service_description != '' ORDER BY service_description ASC");
	$descriptions = array();
	echo '<option value="">Select service</option>';
	while ($row = $result->fetch(PDO::FETCH_ASSOC)) {
		$selected = false;
		$service_description = $row['service_description'];
		if (isset($descriptions[$service_description]))
			continue;
		if (!isset($legal_objects[$row['id']]))
			continue;
		$descriptions[$service_description] = 1;
		if ($template) {
			if ($service_description == $template['service']) {
				$selected = true;
			}
		}

		if ($selected) {
			echo "<option value='$service_description' selected='selected'>$service_description</option>\n";
		} else {
			echo "<option value='$service_description'>$service_description</option>\n";
		}
	}
	unset($result);
	echo "</select></td></tr>";

	echo "<input type='hidden' name='file' value='$file'>";
	echo "<tr><td valign='top'>Hosts:</td><td>";
	$result = get_objects_for_user('host');

	$sel_hosts = false;
	$hosts = false;
	foreach ($result as $hostname) {
		$selected = false;
		if ($template) {
			foreach ($template['hosts'] as $key=>$host) {
				if ($hostname == $host) {
					$selected = true;
				}
			}
		}

		if ($selected) {
			$sel_hosts[] = $hostname;
		}
		$hosts[$hostname] = $hostname;
	}

	$page->make_multi_selection($hosts, $sel_hosts, 'hosts');
	echo "</td></tr>";
	echo "<tr><td><input type='submit' value='Save' onclick='loopElements(this.form); return true;' /></td><td align='right'><input type='button' value='Cancel' onclick='self.location.href=\"pnp.php\"' /><input type='reset' value='Reset' onclick='self.location.reload();' /></td></tr>";
	echo "</form>";
	echo "</table>";
	echo '<script type="text/javascript">pnp_trigger_selected();</script>';
} else {
	$special_dir = "/opt/monitor/op5/pnp/templates.special";
	if ($handle = opendir($special_dir)) {
		echo "<ul>";
		while ($file = readdir($handle)) {
			if (substr($file, -3) == "php") {
				$file_handle = fopen($special_dir . "/" . $file, "r");
				$file_content = file_get_contents($special_dir . "/" . $file);
				$nacoma_created = explode("\n", $file_content);
				foreach ($nacoma_created as $verify) {
					if (substr($verify, 0, 7) === "#NACOMA") {
						echo "<li><a href='pnp.php?mode=edit&file=$file'>$file</a> (<a href='pnp.php?mode=delete&file=$file'>Delete</a>)</li>\n";
						continue;
					}
				}
			}
		}

		echo "<ul>";
		echo "<form action='pnp.php' method='get'>";
		echo "Name of Combined Graph: <input type='text' name='file' />";
		echo "&nbsp;<input type='submit' name='mode' value='Add' />";
	} else {
		echo "Can't open special template dir";
	}
}

echo '<div id="progress_div" style="padding: 10px 0px;"></div>';
$page->html_end();
