<?php
require_once('classes/common_gui.php');
require_once('include/clone.inc.php');
require_once('include/prototype.inc.php');
require_once('include/objlock.inc.php');

$page->html_start();

die_if_locked_hard();

// only instantiate class when obj_type available
if ($input->obj_type) {
	$obj_class = $input->obj_type . '_class';

	require_once("classes/".$obj_class.".php");
	if ($input->obj_id){
		$obj = new $obj_class($input->obj_id);
	} else {
		$obj = new $obj_class();
	}
}

if (isset($obj) && $obj && $input->obj_id && !$obj->can_user_read($input->obj_type, $input->obj_id))
	deny_access("You're not allowed to access profiles based on this object");
if ($pid = (int)$input->get_numeric('profile_id')) {
	$sql = 'SELECT object_type, object_name FROM profiles WHERE id = '.$pid;
	$res = pdo_exec_query($sql);
	$profile = $res->fetch(PDO::FETCH_ASSOC);
	unset($res);
	if (!$obj || !$obj->id) {
		require_once('classes/'.$profile['object_type'].'_class.php');
		$classname = $profile['object_type'].'_class';
		$obj = new $classname($profile['object_name']);
	}
	if (!$obj->can_user_write($obj->type, $obj->id))
		deny_access("You're not allowed to modify profiles based on this object");
}

switch (strtolower(trim($input->action))){
	case 'use':
		// -- display form before creation, nr of copies/clones etc...
		use_profile_step1((int)$input->get_numeric('profile_id'), $input->obj_type);
		break;

	case 'create':
		echo '<h2>Create clone from saved profile</h2>';
		// -- create 'clones' from saved profile
		$sub_objs_to_clone 	= $input->get_array('sub_obj');
		$clone_detail 		= $input->get_array('clone_detail');

		if ($input->obj_type=='host'){
			host_clone_step_3($obj, $clone_detail, $sub_objs_to_clone);
		} else {
			header('location: clone.php?obj_type='.$input->obj_type.'&obj_id='.$input->obj_id.'&action=Clone%20services');
			exit;
		}
		break;

	case 'edit':
		echo '<h2>Edit profile</h2>';
		profileEditForm($input->get_numeric('profile_id'), $input->get_string('ret_page'), $input->obj_type, $input->obj_id);
		break;

	case 'update':
		// Save edited profile... (name + desc)
		echo '<h2>Update profile</h2>';
		updateProfile($input->get_numeric('profile_id'), $input->get_string('profile_name'), $input->get_string('profile_description'), $input->obj_type);
		echo "Updated profile...";
		echo "<br /><br /><a href=\"".$input->get_string('ret_page')."?obj_type=".$input->obj_type."&obj_id=".$input->get_numeric('obj_id')."\" class=\"back\">back</a>";
		break;

	case 'delete':
		if (!deleteProfile($input->get_numeric('profile_id'))){
			echo "Unable to delete profile...";
		} else {
			echo "Profile deleted...";
		}
		if ($input->get_string('return_path')!=''){
			echo "<br /><br /><a href=\"".urldecode($input->get_string('return_path'))."\" class=\"back\">back</a>";
		} else {
			echo "<br /><br /><a href=\"".$input->get_string('ret_page')."?obj_type=".$input->obj_type."&obj_id=".$input->get_numeric('obj_id')."\" class=\"back\">back</a>";
		}
		break;
 case 'create profile':
	require_once('classes/host_class.php');
	$obj = new host_class($input->obj_id);
	echo "<h2>Create profile from host '" . $obj->obj['host_name'] . "'</h2>\n";
	echo "<img src=\"images/icons/arrow.gif\" alt=\"\" class=\"show\" /> &nbsp;<a href='edit.php?obj_type=$obj->type&obj_id=$obj->id' class=\"arrow\">Edit this object</a>\n";
	echo '</div>'; // #pad
	echo "<div id=\"object-table\">";
	$page->form_start('mk_profile');
	ask_for_profile_saving_input('');
	echo "<br /><table class='max zebra ObjTable'>\n";
	ask_host_clone_questions($obj);
	echo "</table>\n";
	$page->hidden_var('obj_type', $obj->type);
	$page->hidden_var('obj_id', $obj->id);
	$page->submit_button('Save as profile');
	$page->form_end();
	echo '</div>'; // #content-info
	break;

 case 'save as profile':
	echo '<h2>Profiles</h2>';
	require_once('classes/host_class.php');
	$obj = new host_class($input->obj_id);
	$name = saveAsProfile($obj,  $input->get_string('profile_name'),
						  $input->get_string('profile_description'),
						  $input->get_array('sub_obj'));
	if ($name) {
		printprofilesbytype('host');
	}
	else {
		echo "There was an error saving your profile<br />\n";
	}
	break;

	default:
		echo '<h2>Profiles</h2>';
		// List available prototypes
		printProfilesByType('host');
		//printProfilesByType('service');
		echo "<div style=\"float: left;  margin-top: 15px;\">To create a profile, select a host below and click 'Create profile'<br /><br />\n";
		$page->form_start('profile_create');
		$page->hidden_var('obj_type', 'host');
		get_object_index_table('host');
		$page->make_filtered_selection($Object_Index_Table['host'], '', 'obj_id');
		$page->submit_button('Create profile', 'action', true);
		$page->form_end();
		echo '</div>';
		echo '</div>';
}

$page->html_end();
