#!/bin/sh

nacoma_dir=`dirname $0`

give_all_rights ()
{
	php -r "$(cat <<EOS
		require_once('$nacoma_dir/include/import.inc.php');
		pdo_exec_query("UPDATE role_permissions SET rule = 'allow' WHERE role_id=1");
EOS
);"
}

give_restricted_rights ()
{
	php -r "$(cat <<EOS
		require_once('$nacoma_dir/include/import.inc.php');
		pdo_exec_query("DELETE FROM role_permissions WHERE role_id=1");
		// Note: {host,service}group is in both arrays
		foreach (array("contact", "hostgroup", "servicegroup", "contactgroup", "template", "host_template", "service_template", "contact_template", "command", "timeperiod", "FILE", "servicedependency", "serviceescalation", "hostdependency", "hostescalation") as \$type) {
			pdo_exec_query("INSERT INTO role_permissions (role_id, object_type, rule) VALUES (1, '\$type', 'no-edit')");
			pdo_exec_query("INSERT INTO role_permissions (role_id, object_type, rule) VALUES (1, '\$type', 'no-create')");
		}
		foreach (array("host", "service", "hostgroup", "servicegroup") as \$type) {
			pdo_exec_query("INSERT INTO role_permissions (role_id, object_type, rule) VALUES (1, '\$type', 'by-contact-access')");
		}
		pdo_exec_query("INSERT INTO role_permissions (role_id, object_type, rule) VALUES (1, 'access_rights', 'no-access')");
		cache_access_rights();
EOS
);"
}


case "$1" in
	--all-rights)
		give_all_rights
		;;
	--restricted-rights)
		give_restricted_rights
		;;
	*)
		echo "$0 [--all-rights|--restricted-rights]"
		echo "This script configures what objects a user without authorized_for_all_hosts is"
		echo "by default allowed access to."
		echo "    --all-rights        Give users access to all objects always."
		echo "    --restricted-rights Give users access to the hosts and services that are"
		echo "                        visible in ninja, and no other objects."
		echo "A user with authorized_for_all_hosts set will always have access to all obects"
esac
