#!/usr/bin/php -q
<?php
# proof-of-concept code of how to apply a given contactgroup to
# host and all its services or all hosts in a hostgroup and all
# the hosts' services
#
# Copyright(c) 2008 op5 AB
# All rights reserved.
#

$DEBUG = false;
require_once('include/data.inc.php');
require_once('include/import.inc.php');
require_once('classes/contactgroup_class.php');
require_once('classes/host_class.php');
require_once('classes/service_class.php');
require_once('classes/hostgroup_class.php');
import_config("console user");

$self = $argv[0];
function usage($msg = false)
{
	global $self;

	echo "\n";
	echo "Usage: $self --contactgroup <contactgroup> \n";
	echo "             [--hostgroup <hostgroup> | --host <host>]\n";
	echo "\n";

	if ($msg)
		echo "$msg\n\n";

	exit(1);
}


$options = array('contactgroup' => false,
				 'hostgroup' => false,
				 'host' => false,
				 );

$contactgroup = false;
$hostgroup = false;
$hostname = false;
if ($argc < 5)
	usage();

for ($i = 1; $i < $argc - 1; $i++) {
	switch ($argv[$i]) {
	 case '--hostgroup':
		$hostgroup = $argv[++$i];
		break;
	 case '--host':
		$hostname = $argv[++$i];
		break;
	 case '--contactgroup':
		$contactgroup = $argv[++$i];
		break;
	 case '--help': case '-h': case 'help':
		usage();
		break;
	 default:
		usage("Unrecognized option: $argv[$i]");
	}
}

if (!$contactgroup || (!$hostname && !$hostgroup))
	usage("Must specify --contactgroup and either --hostgroup or --host");

# Find the objects we're working with here
$cg = new contactgroup_class;
$cg->get_object_by_name($contactgroup);

$hostlist = array();
if ($hostgroup) {
	$hg = new hostgroup_class;
	$hg->get_object_by_name($hostgroup);
	$hostlist = $hg->obj['members'];
	$hg = false;
}
if ($hostname) {
	$host = new host_class;
	$host->get_object_by_name($hostname);
	$hostlist[$host->id] = $host->id;
}

# do the actual applying.
echo "Applying contactgroup '" . $cg->obj['contactgroup_name'] .
	"' to the following objects:\n";
foreach ($hostlist as $host_id) {
	$host = new host_class($host_id);
	$host->obj['contact_groups'][$cg->id] = $cg->id;
	#echo "host #$host->id: '"
	echo $host->obj['host_name'] . "\n";
	$host->save_object();

	# if (do services too...)
	$servicelist = $host->get_sub_object_ids('service', 'host_name');
	foreach ($servicelist as $service_id) {
		$service = new service_class($service_id);
		echo "  " . $service->obj['service_description'] . "\n";
		if (isset($service->obj['contact_groups'][$cg->id]))
			continue;
		$service->obj['contact_groups'][$cg->id] = $cg->id;
		$service->save_object();
		$service = false;
	}
}

echo "\n";
echo "Now use the 'save' command from the webconfiguration interface\n";
echo "to activate these changes.\n\n";
